/*-----------------------------
This header file defines constants for new global flags added for the Quests & Interactions patch.

Author: Alun Bestor (exult@washboardabs.net)
Last modified: 2005-04-27
-------------------------------*/

enum new_misc_flags
{
	//The player has heard a Fellowship member rabbit on about their philosophy.
	//Used for new conversation behaviour by askAboutPhilosophy() in npcs.uc.
	HEARD_PHILOSOPHY = 0x350,

	GAVE_CAMILLE_PAYMENT			= 0x351,	//Gave Camille the widow Thurston's payment for her wheat delivery
	THURSTON_WARNED_ABOUT_MILLING	= 0x352		//Thurston is angry about the avatar using his mill
};

//Flags used by the selling-fish-to-Gordon conversation option (use static vars instead?)
enum gordon_fish_sales
{
	ASKED_GORDON_ABOUT_FISHING	= 0x360,
	HIRED_BY_GORDON				= 0x361,
	GOT_GORDONS_ROD				= 0x362
};

enum menion_swordmaking
{
	MENION_HAS_SWORD		= 0x363,	//Menion is waiting to give you a sword you were carrying too much to accept
	GOT_SWORDSMITHING_XP	= 0x364		//Player got experience reward for forging sword
};

//Flags used by the Rune of Honor quest
enum rune_of_honor_flags
{
	TOLD_ABOUT_RUNE				= 0x370,	//Talked to Finnigan about Trinsic and the Rune of Honor (starts off quest)

	NEED_PERMISSION_FOR_RUNE	= 0x371,	//Talked to Candice about Rune and need LB's permission to return it
	GOT_PERMISSION_FOR_RUNE		= 0x372,	//Got LB's permission to return Rune

	NEED_REPLICA_RUNE			= 0x373,	//Candice wants a replica made
	KNOWS_ARTISAN_FOR_RUNE		= 0x374,	//Found out who can make the replica
	GOT_REPLICA_RUNE			= 0x375,	//Received the replica rune (prevents it being given twice)

	FAKE_RUNE_IN_TRINSIC		= 0x376,	//The replica is on the pedestal in Trinsic
	REAL_RUNE_IN_TRINSIC		= 0x377,	//The real rune is on the pedestal in Trinsic

	FAKE_RUNE_IN_BRITAIN		= 0x378,	//The replica is on the pedestal in Britain
	RUNE_TAKEN_FROM_BRITAIN		= 0x379,	//The real rune has been removed from the pedestal in Britain
											//(needs to be inverted because it will start out false)

	RUNE_THEFT_TIMER_RUNNING	= 0x37A,	//The theft discovery timer has been started (prevents it restarting)
	RUNE_THEFT_DISCOVERED		= 0x37B,	//Finnigan has got angry letter, demands you return the rune

	RETURNED_STOLEN_RUNE		= 0x37C,	//Returned the real rune to Britain after stealing it (failed end of quest)
	RETURNED_RUNE_PROPERLY		= 0x37D,	//Returned the real rune to Trinsic after getting replica (successful end of quest)
	REWARDED_FOR_RUNE			= 0x37E,	//Got the XP reward for returning the Rune
	RUNE_QUEST_COMPLETE			= 0x37F
};
