/* Egg used on baking hearths to cook dough that is placed upon it: Reimplemented to add in more dough recipes */
bakeBread 0x635()
{
	var dough;
	var dough_pos;
	var dough_frame;
	var hearth;
	var bread;
	var bread_frames;
	var bread_frame;
	var bread_name;
	var rand;

	//egg called this function when dough was placed upon it
	if (event == EGG)
	{
		dough = UI_find_nearby(item, SHAPE_DOUGH, 0, 0);
		//Added: also checks that the dough isn't just raw flour (take that, you bastards)
		if (dough && UI_get_item_frame(dough) > 0)
		{
			//in 60 ticks, the dough itself will BakeBread in order to turn into bread
			script dough after 60 ticks	{ call bakeBread; }
			if (UI_get_random(2) == 1) randomPartyBark("@Do not overcook it!@");
		}
	}

	//dough called function to turn into bread
	else if (event == SCRIPTED)
	{
		dough_pos	= UI_get_object_position(item);
		hearth		= UI_find_nearby(item, SHAPE_HEARTH, 2, 0);

		//Who the hell wrote this?? Why not just check for the existence of a hearth?
		if(UI_get_array_size(hearth) > 0)
		{
			dough_frame	= UI_get_item_frame(item);

			UI_remove_item(item);
			bread = UI_create_new_object(SHAPE_FOOD);
			if (bread)
			{
				UI_set_item_flag(bread, TEMPORARY);

				//This whole bit has been pulled apart and rewritten to support multiple kinds of bread

				//Flat dough was used: this causes pastry to be born!
				if (dough_frame == FRAME_DOUGH_FLAT)
				{
					bread_frame = FRAME_PASTRY;
					bread_name = "pastry";
				}
				else if (dough_frame == FRAME_DOUGH_PIE)
				{
					bread_frame = FRAME_PIE;
					bread_name = "pie";
				}
				//Randomly decides between fruitcake and regular cake
				else if (dough_frame == FRAME_DOUGH_CAKE)
				{
					if (UI_get_random(3) == 1) bread_frame = FRAME_FRUITCAKE;
					else bread_frame = FRAME_CAKE;
					bread_name = "cake";
				}

				//Ball dough was used: this makes some kind of regular bread
				//(weighted so that the small round loaves occur twice as often)
				else if (dough_frame == FRAME_DOUGH_BALL)
				{
					bread_name = "bread";
					rand = UI_get_random(4);

					if		(rand == 1) bread_frame = FRAME_BAGUETTE;
					else if	(rand == 2) bread_frame = FRAME_ROLLS;
					else				bread_frame	= FRAME_BREAD;
				}

				UI_set_item_frame(bread, bread_frame);

				if (UI_update_last_created(dough_pos))
				{
					rand = UI_get_random(3);
					if		(rand == 1) randomPartyBark("@I believe the " + bread_name + " is ready.@");
					else if (rand == 2) randomPartyBark("@Mmm... Smells good.@");
				}
			}
		}
	}
}

/* Reimplemented to offload doubleclick behaviour to BakeBread, since the silly sods who programmed it to start with duplicated the behaviour in two locations. */
Dough 658()
{
	var dough_frame;
	var target;
	var target_shape;
	var target_pos;

	//this behaviour allows you to place bread upon a hearth without drag-dropping
	if (event == DOUBLECLICK)
	{
		dough_frame = UI_get_item_frame(item);
		if (UI_get_item_frame(item) > 0)	//dough is not flour
		{
			target = UI_click_on_item();
			target_shape = UI_get_item_shape(target);
			if (target_shape == SHAPE_HEARTH)
			{
				if (UI_set_last_created(item))
				{
					target_pos = UI_get_object_position(target);
					//choose a random position somewhere along the hearth
					//tweaked to allow one more space for it...
					//...and then untweaked again, as it makes the dough too hard to see
					target_pos[X] = target_pos[X] - UI_die_roll(1, 2);
					target_pos[Z] = target_pos[Z] + 1;

					//now place the dough there
					if (UI_update_last_created(target_pos))
					{
						script item after 60 ticks	{ call bakeBread; }	//Changed to call BakeBread instead of Dough
						if (UI_get_random(2) == 1) randomPartyBark("@Do not overcook it!@");
					}
				}
			}
		}
	}
}