//Changes use message to mention sewing into garments (and to stop saying that it would "fetch a fair price in Minoc", as there's noone you can sell cloth to in the entire game!)
Cloth 851()
{
	if (event == DOUBLECLICK)
	{
		randomPartySay("\"That appears to be fine cloth, thou couldst sew it into clothing if thou hast any thread.~\"Or perhaps when we are in a fix, thou couldst cut it into bandages with shears.\"");
	}
}


//sew a bolt of cloth into your choice of pretty garment
//Todo: different kinds of garments need different materials, possibly multiple materials (e.g. Avatar Costume)
sewCloth 0xB16(var cloth)
{
	var garment;
	var garment_shape;
	var garment_frame;
	var comments;

	AVATAR.say("What sort of garment dost thou wish to sew from this cloth?");
	converse (["shirt", "cloak", "dress", "trousers", "Avatar costume", "cuddly toy", "nothing"])
	{
		case "shirt":
			garment_shape = SHAPE_TOP;
			garment_frame = FRAME_SHIRT;
			break;
		case "cloak":
			garment_shape = SHAPE_CLOAK;
			garment_frame = UI_die_roll(0,3);
			break;
		case "dress":
			garment_shape = SHAPE_TOP;
			garment_frame = UI_die_roll(1,2);
			break;
		case "trousers":
			garment_shape = SHAPE_PANTS;
			garment_frame = UI_die_roll(0,5);
			break;
		case "Avatar costume":
			garment_shape = SHAPE_COSTUME;
			garment_frame = 0;
			break;
		case "cuddly toy":
			garment_shape = SHAPE_TOY;
			garment_frame = UI_die_roll(0,1);
			break;
		case "nothing":
			break;
	}

	if (garment_shape)
	{
		//cuddly toys also need wool for stuffing!
		//Note: for now this doesn't actually remove the wool, since only a small amount would be needed
		if (garment_shape == SHAPE_TOY)
		{
			if (!UI_count_objects(PARTY, SHAPE_WOOL, QUALITY_ANY, FRAME_ANY))
			{	
				AVATAR.say("Thou must also have some wool with which to stuff the toy.");
				return;
			}
		}

		UI_remove_item(item);	//get rid of the thread

		//change the cloth into the garment (hopefully this will carry over the right properties too: it appears to carry over dimensions at least)
		UI_set_item_shape(cloth, garment_shape);
		UI_set_item_frame(cloth, garment_frame);

		//reset these flags just in case
		UI_set_item_flag(cloth, OKAY_TO_TAKE);
		UI_clear_item_flag(cloth, TEMPORARY);

		//now, say some comments about it
		avatarBark("\"Voila!\"");

		if (garment_shape == SHAPE_TOY) comments = ["\"Aw, 'tis so cute!\"", "\"Could we name him Draco?\""];

		else comments = ["\"T'will look divine on thee!\"",
						"\"Tres elegant!\"",
						"\"'Tis all the rage in Britain.\""];

		delayedBark(randomPartyMember(), randomIndex(comments), 10);
	}
}

extern Loom 261();
Thread 654()
{
	var target;
	var target_shape;
	var pos_x;
	var pos_y;
	var pos_z;

	//Player doubleclicked on thread: march them to the thread and pick it up
	//Once we have it, this function gets called again as event = SCRIPTED
	if (event == DOUBLECLICK) gotoAndGet(item);

	//Player is carrying the thread and ready to use it
	else if (event == SCRIPTED)
	{
		target = UI_click_on_item();
		target_shape = UI_get_item_shape(target);

		//loom was clicked on: go to the loom and run the weaving animation
		if (target_shape == SHAPE_LOOM)
		{
			UI_close_gumps();

			//only go to the bottom edge of the loom
			pos_x = [0, -1, -2];
			pos_y = [1, 1, 1];
			pos_z = -1;
			gotoObject(target, pos_x, pos_y, pos_z, Loom, target, 7);
		}
		//thread was used on cloth - get sewing!
		else if (target_shape == SHAPE_CLOTH) sewCloth(target);

		//something else was clicked on; advise the player what they can do with thread
		else
		{
			randomPartySay("\"Why dost thou not weave cloth with that thread on the loom?~\"Or if thou hast cloth already, thou couldst use this thread to sew a fine garment with it.\"");
		}
	}
}