const int FIREPIT_COOL_SPEED = 20;	//The number of ticks it takes the firepit to cool down one notch (increased from 15 to 20)
const int SOUND_FIREPIT = 47;		//The sound made when the flames roar higher and higher and HIGHER

extern heatSwordBlank 0xB30();
Firepit 739()
{
	var is_fov;
	var current_frame;
	var min_frame;
	var max_frame;
	var target_frame;
	var num_cooling_frames;

	var nearby_swordblanks;
	var swordblank;
	var firepit_pos;
	var swordblank_pos;

	//Firepit is being heated up by bellows
	//This behaviour was moved from Bellows() itself, and reorganised so that regular firepits behave the same as the FoV one (along with heating up regular swordblanks!)
	if (event == SCRIPTED)
	{
		current_frame = UI_get_item_frame(item);
		is_fov = (current_frame > 3);

		//well lookee here, a Forge of Virtue forge
		if (is_fov)	{ min_frame = 4; max_frame = 7; }
		else		{ min_frame = 0; max_frame = 3; }

		num_cooling_frames = current_frame - min_frame;

		target_frame = current_frame + 1;
		if (target_frame > max_frame) target_frame = max_frame;
		num_cooling_frames = target_frame - min_frame - 1;

		//Heat the fire up another notch, then let it cool down
		script item
		{
			sfx SOUND_FIREPIT;
			wait 1;
			frame target_frame;
			repeat num_cooling_frames { wait FIREPIT_COOL_SPEED; previous frame; };
		}

		//Firepit is at its hottest - start heating any swordblanks up
		if (current_frame == max_frame)
		{
			//find all swordblanks nearby to heat them
			nearby_swordblanks = UI_find_nearby(item, SHAPE_SWORDBLANK, 3, 176);	//last parameter copied from Bellows()
			for (swordblank in nearby_swordblanks)
			{
				//Make sure the swordblank is actually on top of the firepit
				firepit_pos	= UI_get_object_position(item);
				swordblank_pos	= UI_get_object_position(swordblank);

				var x_offset = swordblank_pos[X] - firepit_pos[X];
				var y_offset = swordblank_pos[Y] - firepit_pos[Y];
				var z_offset = swordblank_pos[Z] - firepit_pos[Z];

				//avatarBark("X: " + x_offset + " Y: " + y_offset + " Z: " + z_offset);

				//acceptable range
				var x_range = [0, -1, -2];
				var y_range = [0, -1, -2];
				var z_range = [2, 3];
				
				//Make sure swordblank is on top of the firepit and within a certain zone
				//(pretty lenient, as it's fucking hard to position the blank right over the coals - try tweaking the shape offsets)
				if (x_offset in x_range && y_offset in y_range && z_offset in z_range) 
				{
					//regular forges won't heat up the Black Sword!
					//Disabled for now for testing
					if (!is_fov && UI_get_item_frame(swordblank) >= 8)
					{
						randomPartySay("\"Avatar, I do not think a regular forge is hot enough to temper such a blade. Thou shouldst take it to the Forge of Virtue.\"");
					}
					else script swordblank { call heatSwordBlank; }
				}
			}
		}
	}
}

//Swordblank was doubleclicked and used on firepit - place it in the center
useSwordOnFirepit 0x68C()
{
	var firepit = UI_find_nearest(UI_get_avatar_ref(), SHAPE_FIREPIT, 5);
	if (firepit) placeOnTarget(item, firepit, 0, -1, 2); //now, place it on the firepit
}