Hammer 623 ()
{
	var target;
	var item_shape;
	var anvil;
	var target_shape;
	var target_frame;
	var swordblank;
	var target_direction;

	//Hammer was doubleclicked, use it on something
	if (event == DOUBLECLICK)
	{
		//Hammer is not readied
		if (!UI_is_readied(AVATAR, WEAPON_HAND, SHAPE_HAMMER, QUALITY_ANY))
		{
			randomPartySay("\"Thou must wield the hammer in thine hand to use it.\"");
			return;
		}

		UI_close_gumps();	//clear the view
		target = UI_click_on_item();
		target_shape = UI_get_item_shape(target);

		//used on swordblank, make sure the swordblank is on an anvil
		if (target_shape == SHAPE_SWORDBLANK)
		{
			swordblank = target;
			anvil = UI_find_nearest(target, SHAPE_ANVIL, 3);
			if (anvil)
			{
				//The sword is correctly positioned: go to the anvil, and call useHammerOnSwordblank()
				if (onAnvil(swordblank, anvil)) gotoObject(anvil, 0, 2, 0, useHammerOnSwordblank, swordblank, SCRIPTED);
				//Otherwise, advise the player to adjust its position
				else randomPartySay("\"Thou shouldst place the blade squarely upon the anvil.\"");
			}
			else randomPartySay("Thou must place the blade upon an anvil before hammering it.");
		}

		//used on anvil, make sure there's a swordblank on top of it
		else if (target_shape == SHAPE_ANVIL)
		{
			swordblank = UI_find_nearest(target, SHAPE_SWORDBLANK, 3);
			anvil = target;
			if (swordblank)
			{
				//The sword is correctly positioned: go to the anvil, and call useHammerOnSwordblank()
				if (onAnvil(swordblank, anvil)) gotoObject(anvil, 0, 2, 0, useHammerOnSwordblank, swordblank, SCRIPTED);
				//Otherwise, advise the player to adjust its position
				else randomPartySay("\"Thou shouldst place the blade squarely upon the anvil.\"");
			}
		}
	}
}

//This is called when the avatar is in front of the anvil and ready to use their hammer on the swordblank.
//We can get to this function by:
//1. Doubleclicking a wielded hammer and clicking on a swordblank on top of an anvil	(Hammer() in hammer.uc)
//2. Doubleclicking a swordblank that is on top of an anvil while wielding a hammer		(SwordBlank() in swordblank.uc) 
//3. Doubleclicking an anvil that has a swordblank on top of it while wielding a hammer	(Anvil() in anvil.uc) 
//<item> is the swordblank in question.
//Todo: rewrite this function so that the swordblank doesn't run a script, as this interferes with the cooling-down script!

const int SOUND_HAMMER_SWORD = 45;

//extern temperSword 0x691();
extern temperSword 0xB35();
useHammerOnSwordblank 0xB34()
{
	var current_frame;
	var is_blacksword;
	var hot_frames;		//Hot enough to hammer
	var warm_frames;	//Heated, but not hot enough
	var cool_frames;	//Cooled down completely

	//make sure they're still wielding the hammer! This should always be the case, though
	if (!UI_is_readied(AVATAR, WEAPON_HAND, SHAPE_HAMMER, QUALITY_ANY)) return;

	current_frame = UI_get_item_frame(item);
	is_blacksword = isBlackSword(item);

	if (is_blacksword)	{ hot_frames = [10, 11, 12];	warm_frames = [8, 9];	cool_frames = [13, 14, 15]; }
	else				{ hot_frames = [2, 3, 4, 5];	warm_frames = [1];		cool_frames = [0, 6, 7]; }

	if		(current_frame in cool_frames)	avatarBark("@The sword is not heated.@");
	else if (current_frame in warm_frames)	avatarBark("@The sword is too cool.@");

	//Ok, the blade is hot enough, bash it good
	else if (current_frame in hot_frames)
	{
		//Swing that hammer good
		script AVATAR
		{
			face directionFromAvatar(item);
			actor frame USE;
			actor frame SWING_1;
			actor frame SWING_3;
			sfx SOUND_HAMMER_SWORD;	//Clang
			call temperSword;		//Set the effect that the bashing is having on the swordblank
			actor frame USE;
			actor frame STAND;
		}
		
		//We now call temperSword via the avatar instead, so this is disabled
		/*
		script item
		{
			nohalt;
			wait 4;
			sfx SOUND_HAMMER_SWORD;	//Clang
			call temperSword;	//Set the effect that the bashing is having on the swordblank
			call startCooling;	//Continue cooling down
		}
		*/
	}
}