/* This include file contains behaviours for grinding flour from wheat */

//Wheat can be used on a millstone to create a sack of flour
extern Millstone 711();
Wheat 677()
{
	var target;
	var target_offsetx;
	var target_offsety;

	//Player double-clicked on wheat-sack - it must first be picked up in order to be used
	//Once the player has it, this function gets called again with event = SCRIPTED
	if (event == DOUBLECLICK) gotoAndGet(item);

	//Wheat-sack has been acquired and is now ready to use on millstone
	else if (event == SCRIPTED)
	{
		UI_close_gumps();
		target = UI_click_on_item();
		if (UI_get_item_shape(target) != SHAPE_MILLSTONE)
		{
			randomPartySay("\"Why not try grinding the wheat in a millstone?\"");
			return;
		}

		//pathfind to the top edge of the millstone
		target_offsetx = [-1, 0, 1];
		target_offsety = [-5, -5, -5];

		//call Millstone() to handle the actual grinding of the wheat
		gotoObject(target, target_offsetx, target_offsety, -3, Millstone, target, SCRIPTED);
	}
}


//Performs grindage upon a sack of wheat
const int SOUND_GRIND = 26;
extern createFlour 0xB07();
Millstone 711()
{
	var wheat;

	//player double-clicked on the millstone
	if (event == DOUBLECLICK)
	{
		randomPartySay("\"Try grinding wheat upon this millstone.\"");
		return;
	}

	//player used wheat on the millstone
	else if (event == SCRIPTED)
	{
		//find the first wheat sack the player is carrying and remove it
		wheat = UI_get_cont_items(UI_get_avatar_ref(), SHAPE_WHEAT, QUALITY_ANY, FRAME_ANY);
		UI_remove_item(wheat);

		//animate the avatar doing things to the millstone
		script AVATAR
		{
			nohalt;
			call freeze;	//prevent player movement
			face directionFromAvatar(item);
			repeat 3
			{
				sfx SOUND_GRIND;
				actor frame USE; wait 2;
				actor frame STAND; wait 2;
			};
			call unfreeze;
		}

		if (isNearby(THURSTON) && gflags[THURSTON_WARNED_ABOUT_MILLING] && UI_get_random(2) == 1)
		{
			delayedBark(THURSTON, "I have told thee before!", 10);
		}

		//call createFlour() at end of animation
		//(we do this in a separate script block, so that the itemref is set properly in the called function)
		script item after 28 ticks	{ call createFlour; }
	}
}

//Create a new flour sack
createFlour 0xB07()
{
	var flour;
	var target_pos;

	//create the new flour object
	flour = UI_create_new_object(SHAPE_KITCHEN_ITEM);
	if (!flour) return;
	UI_set_item_frame(flour, FRAME_FLOURSACK_OPEN);	//changed from FRAME_FLOURSACK

	UI_set_item_flag(flour, TEMPORARY);
	UI_set_item_flag(flour, OKAY_TO_TAKE);

	target_pos = UI_get_object_position(item);
	//place it on the middle right-hand side of the millstone
	target_pos[X] = target_pos[X] + 1;
	target_pos[Y] = target_pos[Y] - 3;

	UI_update_last_created(target_pos);


	//Added: Check if Thurston is nearby, since he'll object
	if (isNearby(THURSTON) && UI_get_random(2) == 1)
	{
		if (!gflags[THURSTON_WARNED_ABOUT_MILLING])
		{
			THURSTON.say("Thurston approaches you, obviously angry and embarrassed of his anger.~\"I do not want to be rude " + getPoliteTitle() + "...but it is my livelihood to run the mill and grind the wheat. So I ask thou, leavest the job to me!");
			THURSTON.say("\"I shall be happy to sell thee all the flour thou couldst want.\"");
			THURSTON.hide();
			gflags[THURSTON_WARNED_ABOUT_MILLING] = true;
		}
	}
}