//Let's milk us some cow

const int SOUND_MILKING = 2;
milkCow 0xB11()
{
	var cow = item;
	var vessel;			//the empty bucket/pitcher used for milking
	var avatar;
	var filled_frame;	//the correct full-of-milk frame for the bucket/pitcher

	//A bucket is being filled
	if (event == 2)
	{
		//get the first empty bucket we can find that the avatar is carrying
		vessel = UI_get_cont_items(UI_get_avatar_ref(), SHAPE_BUCKET, QUALITY_ANY, FRAME_BUCKET_EMPTY);
		filled_frame = FRAME_BUCKET_MILK;
	}
	//A milk pitcher is being filled
	else if (event == 3)
	{
		//get the first pitcher we can find that the avatar is carrying
		vessel = UI_get_cont_items(UI_get_avatar_ref(), SHAPE_KITCHEN_ITEM, QUALITY_ANY, FRAME_PITCHER);
		filled_frame = FRAME_PITCHER_MILK;
	}

	//place the vessel on the ground beneath the cow
	//disabled: this usually results in it being rendered on top of the cow, and anyway it appears immediately rather than at the end of a leaning-down animation.
	//var target_pos = UI_get_object_position(cow);
	//target_pos[X] = target_pos[X] - 2;
	//moveToLocation(vessel, target_pos);

	if (UI_get_random(10) < 3) delayedBark(avatar, "\"Hold still...\"", 15);

	//UI_set_schedule_type(cow, GRAZE);

	script AVATAR
	{
		nohalt;
		call freeze;	//disable player input while animation is playing

		face WEST;

		//lean down to place the bucket
		actor frame STAND;
		actor frame LEAN;	wait 2;
		actor frame STAND;	wait 2;			

		repeat 3
		{
			sfx SOUND_MILKING;
			actor frame USE;	wait 2;
			actor frame STAND;	wait 2;
		};

		say "\"That's a good girl!\"";
		call unfreeze;
	}
	script vessel after 25 ticks	{ frame filled_frame; }
	script cow 
	{
		nohalt;
		call freeze;	//prevent them from wandering away in the middle of it
		wait 20;
		say "\"MoooOOOoooo\"";
		wait 5;
		call unfreeze;	//ok, you can go now
	}

	//Sarky bastards
	if (UI_get_random(3) == 1) delayedBark(randomPartyMember(), "\"Don't we have a quest?\"", 35);
}

//Called by Bucket() and Pitcher() - directs the player to the cow, and freezes the cow in place till they get there
//Calls milkCow() when the player arrives, using eventid to flag whether a bucket (2) or pitcher (3) was used
gotoCow 0xB18(var cow, var milktype)
{
	UI_close_gumps();

	//UI_set_schedule_type(cow, WAIT);	//stop the cow from moving around

	//make sure the cow is facing the right way for milking (so pathfinding will work properly), and stop them moving around
	//Note: they will be unfrozen once they have been milked, or if the player decides not to milk them. Unfortunately, just using a simple wait (or wait-loop) doesn't stop the GRAZE schedule from making the cow wander off, so we actually have to paralyze them to keep them still.
	script cow { nohalt; call freeze; face EAST; }

	//Go to the cow's udder region (either side will do)
	var cow_offsetx = [-2, -2];
	var cow_offsety = [1, -4];
	gotoObject(cow, cow_offsetx, cow_offsety, 0, milkCow, cow, milktype);

	//Hat tip to Marzo for this one - this will unfreeze the cow if the player cancels the go-to
	UI_set_path_failure(unfreeze, cow, SCRIPTED);
}