/* Candice, the museum curator in Britain. Reimplemented for Rune of Honor quest. */
Candice 0x429 ()
{
	var schedule;
	var wearing_fellowship;
	var part_of_day;
	var near_batlin;

	if (event == DOUBLECLICK)
	{
		schedule = UI_get_schedule_type(item);
		wearing_fellowship = UI_wearing_fellowship();
		part_of_day = UI_part_of_day();

		if (UI_part_of_day() == NIGHT)
		{
			if (nearEachOther(item, BATLIN))
			{
				item.say("Candice is listening intently to the Fellowship meeting.*");
				return;
			}
			else if (gflags[BATLIN_MISSING]) item.say("\"Hast thou seen Batlin? He has not shown up for the Fellowship meeting!\"");
			else
			{
				item.say("\"Oh! I must not stop to speak with thee! I am late for a Fellowship meeting!\"*");
				return;
			}
		}

		if (!gflags[MET_CANDICE])
		{
			item.say("This is a bright woman who looks much younger than she actually is.");
			item.say("\"Well! Thy reputation precedes thee! The Avatar in person! Word has spread that thou wert in Britain!\"");
			gflags[MET_CANDICE] = true;
		}
		//naughty love-tryst with Patterson
		else if (part_of_day == MIDNIGHT && isNearby(PATTERSON))
		{
			item.say("Candice looks guilty about something. She gives you a little wave, but says nothing. She looks at Patterson, hoping that he will do the talking.*");
			return;
		}
		else item.say("\"Yes, Avatar?\" Candice says.");

		//Now get on with the conversation

		//add regular conversation options
		add(["name", "job", "bye"]);
		
		//Additions for Rune of Honor quest
		if (gflags[TOLD_ABOUT_RUNE] && !gflags[RUNE_QUEST_COMPLETE])
		{
			//Player has not got permission yet
			if (!gflags[GOT_PERMISSION_FOR_RUNE]) add("Rune of Honor");

			//Player has got permission
			else if (!gflags[NEED_REPLICA_RUNE]) add("Lord British agrees");

			//Player has the replica ready
			else if (gflags[FAKE_RUNE_IN_BRITAIN] || UI_count_objects(PARTY, SHAPE_RUNE, QUALITY_ANY, FRAME_RUNE_REPLICA)) add("brought replica");
		}

		converse([])
		{
			case "name" (remove):
				say("\"My name is Candice,\" she says brightly. \"I must say I am honored to meet the Avatar!\" She curtsies.");

			case "job":
				if (schedule == TEND_SHOP) say("\"I am the curator of the Royal Museum. Feel free to ask about any of the exhibits.");
				else say("\"I am the curator of the Royal Museum. I hope to see thee there when the museum is open.");

				say("\"I spend the rest of my time working with The Fellowship.\"");
				add(["Royal Museum", "exhibits", "Fellowship"]);

			case "Royal Museum" (remove):
				say("\"It has been in Britain for many, many years. It contains historical artifacts, as well as works of art.\"");
				add(["artifacts", "works of art"]);

			case "exhibits" (remove):
				if (schedule == TEND_SHOP)
				{
					say("\"We have just opened a special section in which thou might be interested -- an exhibit of 'Avatar artifacts'!\"");
					add("Avatar artifacts");
				}
				else say("\"Come to the museum when it is open!\"");

			case "artifacts" (remove):
				say("\"There are relics from early Britannia and even from the Three Ages of Darkness -- back when Britannia was known as Sosaria.\"");

			case "Avatar artifacts" (remove):
				say("\"Well, thou surely must recognize them. They are supposed to be authentic! Things like the Silver Horn and the eight stones. I understand the stones were used for teleportation, and if mages were not so sick in the head these days, they could cast a 'Recall' spell on them to teleport to specific places around Britannia. I believe if one casts a 'Mark' spell on one, thou canst re-assign the teleportation location! But I suppose none of that works anymore.\"");

				if (isNearby(IOLO))
				{
					IOLO.say("Iolo whispers to you, \"Er, Avatar, thou dost know that I do not condone stealing. But, er, I do believe these stones may be useful to us. Perhaps we should come back later when the museum is closed, if thou dost know what I mean? After all, these items technically belong to thee!\"");
					IOLO.hide();
				}

			case "works of art" (remove):
				say("\"Britannia is proud of the artists who donate their works to the museum. Thou wilt see pieces all over the country by Britannian artists Watson, Richard Fox, Randi Frank, Glen Johnson, and Denis Loubet.\"");

			case "Fellowship" (remove):
				if (!wearing_fellowship) say("\"We meet every evening at the Hall. Thou must come and visit!");
				else say("\"Thou must know all about it by now! I hope to see thee at an evening meeting!");

				say("\"The Fellowship has given me a great purpose in life. I have made new friends, and have even found love!\" She giggles. \"Ooops! I gave away my secret! I must not speak of it. Do forget I said that, please?\"");

				add(["purpose", "secret"]);

			case "purpose" (remove):
				say("\"I want to attain a higher level of acceptance in The Fellowship. I want to hear the 'voice'. That is mine one true goal.\"");
				add("voice");

			case "voice" (remove):
				say("\"Dost thou not know? The longer one is a member of The Fellowship, the greater the chances that one will hear the 'voice'. Supposedly, it is a man's voice that thou wilt hear -- perhaps in thy dreams, perhaps while thou art concentrating on something else -- it is a voice that tells thee things, suggests things. I do not know, really. I have not heard it yet, so I am only speaking of what I have heard from others more fortunate than I.\"");
				gflags[HEARD_ABOUT_VOICE] = true;

			case "secret" (remove):
				say("\"What secret? I do -not- have a secret! It was a slip of the tongue. I cannot really speak to anyone about it. Why, if word got out that the Mayor and I... I mean, uhm, -may- I... er, ask thee to forget that I said anything?\"~~Candice turns beet red and turns away.*");
				gflags[HEARD_ABOUT_PATTERSONS_AFFAIR] = true;
				return;

			case "bye":
				say("\"Good day, Avatar.\"*");
				return;


			//Everything beyond this point is added for the Rune of Honor quest
			case "Rune of Honor" (remove):
				//player has already nicked the Rune
				if (gflags[RUNE_TAKEN_FROM_BRITAIN])
				{
					say("You tell her what Finnigan expressed about Trinsic's loss, and ask if you may return the Rune of Honor to its rightful place there.~\"I am surprised thou shouldst ask me -after- thou hast taken the Rune! Put it back at once, and then I might speak to thee about it.\"*");
					return;
				}

				//player already asked once
				else if (gflags[NEED_PERMISSION_FOR_RUNE])
				{
					say("\"Please, ask Lord British if he would agree to let thee have the Rune. 'Tis not my place to say.\"");
				}
				else
				{
					say("You tell her what Finnigan expressed about Trinsic's loss, and ask if you may return the Rune of Honor to its rightful place there. She looks flustered and bites her lip.");
					say("\"I do not understand how they would get comfort from a dusty old relic! They have a Fellowship branch down there, do they not?");
					say("\"In any case, I really cannot give away parts of the collection without proper permission. Perhaps thou couldst ask our sovereign if he would agree to such a thing?\"");

					gflags[NEED_PERMISSION_FOR_RUNE] = true;
				}

			case "Lord British agrees" (remove):
				//check that player hasn't stolen the real Rune already
				if (gflags[RUNE_TAKEN_FROM_BRITAIN])
				{
					say("\"But I have not, " + getPoliteTitle() + "! Please put the Rune back immediately! I shalt not have people tampering with the exhibits, even thee.\"*");
					return;
				}
				else
				{
					say("\"Yes, I received a very nice letter from him personally to say so! It was very flattering, though he spelt my name a little wrong.\"");
					say("She still looks doubtful about the business however.~\"Avatar, please understand... loaning out thine items is one thing, but this would leave a permanent gap in our collection!~\"We can hardly start calling them 'The Seven Runes of the Virtues', now can we? I do not know what to do.\"");
					add("What about a replica?");
				}

			case "What about a replica?" (remove):
				say("\"Why, that could work!\" She brightens up. \"I do not know who could craft such a replica though.~The Runes are made of some kind of rock, I know that much -- perhaps thou couldst find an artisan in Minoc who can work with stone.\"");
				gflags[NEED_REPLICA_RUNE] = true;

			case "brought replica" (remove):
				if (schedule == TEND_SHOP)
				{
					//player has already placed the fake Rune
					if (gflags[FAKE_RUNE_IN_BRITAIN])
					{
						say("\"Aye, I see that thou hast swapped the Runes!\" She admires the new replica. \"'Tis fine work indeed, I shouldst not think our visitors shall know the difference. Thou mayest take the real Rune to Trinsic, as thou wishest.\"");
					}

					//player is carrying fake Rune: swap the real one for the fake
					else if (UI_count_objects(PARTY, SHAPE_RUNE, QUALITY_ANY, FRAME_RUNE_REPLICA))
					{
						say("\"Might I see thy replica?\" She examines it with a critical eye. \"Oh, 'tis a very good likeness! I am glad thou didst find a talented craftsman.~\"I suppose thou wouldst like the real Rune now? Please, go ahead and swap them upon the pedestal.\"");
					}
				}
				else say("\"Please, let us discuss it when I am at the museum.\"");
		}
	}
	else if (event == PROXIMITY) scheduleBarks(item);
}