//Finnigan, the mayor of Trinsic. Reimplemented in preparation for adding a new quest.
extern agreeToInvestigate 0x883();
extern askAboutReport 0x884();
extern askAboutStables 0x885();
extern askCopyProtection 0x886();


Finnigan 0x40C()
{
	var player_name;
	var player_is_female;
	var stolen_msg;
	var barks;

	if (event == DOUBLECLICK)
	{
		player_name = getAvatarName();
		player_is_female = UI_is_pc_female();

		//Player has said they will look in the stables, but hasn't reported about the key yet
		//Edited to offload this work to askAboutStables(), which contains exactly the same conversation tree anyway
		if (gflags[EXPECTED_TO_LOOK_IN_STABLES] == true && gflags[REPORTED_CHRISTOPHERS_KEY] == false)
		{
			item.say("\"Hast thou properly searched the stables?\"");
			askAboutStables();
		}

		else if (gflags[REFUSED_MURDER_INVESTIGATION])
		{
			item.say("\"Hmmm. Hast thou reconsidered mine offer to investigate the murder?\"");
			if (askYesNo())
			{
				say("\"Splendid. Then thou must really be the Avatar after all!\"");
				gflags[REFUSED_MURDER_INVESTIGATION] = false;
				agreeToInvestigate();
			}
			else
			{
				item.say("\"Then leave our people to work it out for themselves.\"*");
				item.hide();

				if (isNearby(IOLO))
				{
					IOLO.say("\"Avatar! I am ashamed of thee! Thou shouldst reconsider!\"*");
					IOLO.hide();
				}
				return;
			}
		}

		else if (!gflags[MET_FINNIGAN])
		{
			UI_halt_scheduled(item);
			UI_set_schedule_type(item, LOITER);	//return Finnigan to his normal schedule

			say("You see a middle-aged nobleman.");
			gflags[MET_FINNIGAN] = true;

			if (isNearby(IOLO))
			{
				item.say("\"Iolo! Who is this stranger?\"*");

				//Tweaked: added in break before "And this is..."
				IOLO.say("\"Why, this is the Avatar!\" Iolo proudly proclaims. \"Canst thou believe it? May I introduce thee? This is Finnigan, the Town Mayor.~And this is " + player_name + ", the Avatar!");

				if (player_is_female) IOLO.say("\"I simply cannot believe she is here!\"*");
				else IOLO.say("\"I simply cannot believe he is here!\"*");

				item.say("The Mayor looks you up and down, not sure if he believes Iolo or not. He looks at Iolo skeptically.");
				IOLO.say("\"I swear to thee, it is the Avatar!\"");
				IOLO.hide();
			}
			else item.say("\"I have heard that thou art the Avatar. I am not certain that I believe it.");

			item.say("The mayor looks at you again as if he were studying every pore on your face. Finally, he smiles.");
			say("\"Welcome, Avatar.\"");
			say("But just as suddenly, Finnigan's face becomes stern.");
			say("\"A horrible murder has occurred. If thou art truly the Avatar, perhaps thou canst help us solve it. I would feel better if thou takest this matter into thine hands. Thou shalt be handsomely rewarded if thou dost discover the name of the killer. Dost thou accept?\"");

			//Edited to offload this work to agreeToInvestigate(), which contains exactly the same conversation tree anyway
			if (askYesNo()) agreeToInvestigate();
			else
			{
				say("\"Well, thou could not be the real Avatar then!\"*");	//what a twat
				gflags[REFUSED_MURDER_INVESTIGATION] = true;
				return;
			}
		}

		//Finnigan is angry about the stolen rune and won't speak to you
		else if (gflags[RUNE_THEFT_DISCOVERED] && !gflags[RETURNED_STOLEN_RUNE])
		{
			item.say("\"I shall not speak to thee until thou hast returned the Rune of Honor to the Museum in Britain. Good day to thee, 'Avatar'.\"*");
			return;
		}

		//Player stole Rune, and Finnigan has just discovered
		else if (gflags[RUNE_THEFT_TIMER_RUNNING] && UI_get_timer(RUNE_THEFT_TIMER) > RUNE_THEFT_DISCOVERY_TIME)
		{
			UI_halt_scheduled(item);
			UI_set_schedule_type(item, LOITER);	//return Finnigan to his normal schedule

			gflags[RUNE_THEFT_TIMER_RUNNING]	= false;
			gflags[RUNE_THEFT_DISCOVERED]		= true;
			item.say("Finnigan descends upon you angrily, waving a letter. \"Avatar! Wouldst thou care to explain -this-?~'Tis from the Great Council in Britain, demanding the return of their purloined Rune of Honor!\"~He glares at you. \"Dost thou realize how much shame thou hast brought upon this town by thine actions? Did the irony of -stealing- the Rune of Honor not occur to thee?~\"Return the Rune to the Museum in Britain at once, or thou shalt no longer be welcome here.\" He then turns on his heels and storms off.*");
			item.hide();

			if (isNearby(IOLO))
			{
				IOLO.say("\"Please " + player_name + ", let us do as he says and go to Britain immediately. Finnigan is a good friend and a good man, and I do not wish him to stay angry at thee.\"");
				IOLO.hide();
			}
			return;
		}
		//Regular conversation starter
		else item.say("\"Yes, Avatar?\" Finnigan asks.");

		add(["name", "job", "murder", "bye"]);

		if (gflags[CAN_GIVE_MURDER_REPORT])				add("report");
		if (gflags[KNOWS_ABOUT_CHRISTOPERS_ARGUMENT])	add(["Fellowship", "Klog"]);
		if (gflags[NEEDS_TRINSIC_PASSWORD] && !gflags[GOT_TRINSIC_PASSWORD]) add("password");
		if (gflags[WAITING_FOR_INVESTIGATION_PAYMENT] && !gflags[FINISHED_MURDER_INVESTIGATION]) add("Pay me now, please");

		//Rune of Honor quest conversation threads
		if (gflags[TOLD_ABOUT_RUNE] && !gflags[RUNE_QUEST_COMPLETE])
		{
			if (
				gflags[REAL_RUNE_IN_TRINSIC] ||		//the real rune is on the pedestal
				gflags[FAKE_RUNE_IN_TRINSIC] ||		//the fake rune is on the pedestal
				UI_count_objects(PARTY, SHAPE_RUNE, QUALITY_ANY, FRAME_RUNE_HONOR) ||	//Carrying real rune
				UI_count_objects(PARTY, SHAPE_RUNE, QUALITY_ANY, FRAME_RUNE_REPLICA)	//Carrying fake rune
			)
			add("Rune returned");
		}

		converse([])
		{
			case "name" (remove):
				say("\"My name is Finnigan.\"");

			case "job":
				say("\"I am the Mayor of Trinsic and have been since I arrived here three years ago.\"");
				add("Trinsic");

			case "Trinsic" (remove):
				if (player_is_female) stolen_msg = "by one who claimed she was the Avatar.";
				else stolen_msg = "by one who claimed he was the Avatar.";

				say("\"Trinsic was once the city of Honor. I suppose it still is. Our Rune of Honor was taken many years ago " + stolen_msg + " I believe it now resides in the Royal Museum in Britain, yet the empty pedestal still remains in the center of town.\"");

				say("\"I feel this is symbolic of the town itself. It is rather empty -- of people, of life, and of honor. 'Tis sad, really.\"");
				
				say("\"Then there is this murder, of course. We have temporarily closed the gates of the city and require a password to get in or out.\"");

				add("password");

				//Added in starter for Rune of Honor quest (checked by Candice in Britain)
				gflags[TOLD_ABOUT_RUNE] = true;


			case "Pay me now, please" (remove):
				say("\"Of course, " + player_name + ". Here is thy gold.\"");

				if (giveGold(100))
				{
					say("\"Here thou art.\"");
					gflags[WAITING_FOR_INVESTIGATION_PAYMENT] = false;
					gflags[FINISHED_MURDER_INVESTIGATION] = true;
				}

				//player was carrying too much stuff
				else say("\"Oh, I am sorry, " + player_name + ". Thou still cannot carry this amount. Thou must return to me later.\"");

			case "murder" (remove):
				if (!gflags[GOT_TRINSIC_PASSWORD])
				{
					say("\"A crime like this has never happened in Trinsic before. I cannot believe this happened to Christopher and Inamo. Please -- explore the town! I would appreciate it if thou wouldst bring me a report on thy progress. Be sure to ask everyone in town about the murder. After speaking with Christopher's son, thou mightest next want to speak with Gilberto, the guard on watch at the dock last night.\"");

					say("The mayor hesitates, then leans in to speak quietly.");

					say("\"Actually, I have seen something like this before. It was about four years ago, in Britain.\"");

					add(["Gilberto", "Christopher", "Inamo", "Britain", "report"]);
					gflags[CAN_GIVE_MURDER_REPORT] = true;	//given ability to report: shows conversation shortcut in future
				}
				else say("\"I hope thou art progressing on the murder investigation.\"");
			
			case "Britain" (remove):
				say("\"'Twas before I came to Trinsic. There was a murder with strikingly similar aspects. A body was found mutilated exactly like poor Christopher. It appeared to be a ritualistic killing. I would wager that whoever was responsible for that murder is the culprit behind this one.\"");

			case "son" (remove):
				say("\"Christopher's son is called Spark. Their house is in the northwest area of town.\"");

			case "Gilberto" (remove):
				say("\"He was struck from behind early this morning and was knocked senseless. Johnson, the morning watch, found him unconscious. He is recuperating at Chantu the Healer's house on the west side of town.\"");
				add(["Johnson", "Chantu"]);

			case "Chantu" (remove):
				say("\"He is our town healer. He hath been here for years. Nice fellow.\"");

			case "report" (remove):
				if (gflags[FINISHED_MURDER_INVESTIGATION]) say("\"I am satisfied with thy report. Please carry on thine investigation, Avatar.\"");
				else
				{
					if (!gflags[STARTED_MURDER_REPORT])
					{
						say("\"Art thou ready to answer some questions concerning the investigation?\"");
						if(askYesNo())
						{
							gflags[STARTED_MURDER_REPORT] = true;
							askAboutReport();
						}
						else say("\"Oh. Well, carry on with thine investigation.\"");
					}
					else
					{
						say("\"Shall we continue thy report?\"");
						if (askYesNo()) askAboutReport();
						else say("\"Oh. Well, carry on with thine investigation.\"");
					}
				}

			case "Fellowship" (remove):
				say("\"Why, they are an extremely helpful group. Their branch office is just east of mine. Very optimistic group of people.\"");

			case "Klog" (remove):
				say("\"He is the Fellowship branch leader. Kind man.\"");

			case "Johnson" (remove):
				say("\"He is probably at the dock right now.\"");

			case "Christopher" (remove):
				say("\"Christopher was the local blacksmith. He lives, or rather -lived-, with his son in the northwest part of town. The blacksmith's shop is in the southwest corner. Christopher was not a rich man by any means -- he barely kept himself and his son alive. But he certainly enjoyed his work.\"");
				add("son");

			case "Inamo" (remove):
				say("\"The Gargoyle Inamo slept in the stables, as I understand it. I believe he emigrated here from Terfin a few months ago. It seems that he was merely a chance victim of someone intent on violence.\"");

			case "password" (remove):
				if (gflags[FINISHED_MURDER_INVESTIGATION] && !gflags[GOT_TRINSIC_PASSWORD])
				{
					say("\"Oh, dost thou want the password now?\"");
					if (askYesNo())
					{
						if (askCopyProtection())
						{
							say("\"Excellent! I have no doubts now that thou art the one true Avatar!\"");
							say("\"Oh-- I almost forgot! The password to leave or enter the town is `Blackbird'!\"*");
							gflags[GOT_TRINSIC_PASSWORD] = true;
							giveExperience(100);
							return;
						}
						else
						{
							say("\"Hmmm. I am afraid that I still have my doubts about thou being the Avatar. My public duty disallows me to give thee the password. I am sorry.\"*");
							return;
						}
					}
					else
					{
						say("The Mayor shrugs and looks at you as if you were mad.*");
						return;
					}
				}
				else
				{
					say("\"I will give thee the password when thou hast given me a report on the progress of thine investigation.\"");
					add("report");
					gflags[NEEDS_TRINSIC_PASSWORD] = true;
				}
			case "bye":
				say("The Mayor nods his head at you and goes on about his business.*");
				break;


			//Everything from this point on has been added for the Rune of Honor quest
			case "Rune returned" (remove):

				//Real rune is on the pedestal
				if (gflags[REAL_RUNE_IN_TRINSIC])
				{
					var noun;
					if (player_is_female) noun = "lady";
					else noun = "man";
					say("He clasps your hand earnestly. \"I thank thee, Avatar! Thou art truly a " + noun + " of honor to return our Rune to us, after all these years.~I hope that its presence and thine efforts shall rekindle the spark of Honor in our town.\" He smiles, but a little wanly.");

					//The replica is in Britain: flag the quest as complete (stops repeating conversations)
					if (gflags[FAKE_RUNE_IN_BRITAIN])
					{
						gflags[RETURNED_RUNE_PROPERLY] = true;
						gflags[RUNE_QUEST_COMPLETE] = true;
					}

					add("But thou dost not believe so?");
				}

				//Fake rune on the pedestal
				else if (gflags[FAKE_RUNE_IN_TRINSIC])
				{
					say("\"I do not wish to alarm thee Avatar, but that Rune thou hast placed upon our pedestal is a fake!~\"I thank thee for thine efforts, but they have been sadly misplaced.\"'twould be an irony indeed for us to display a false icon -- I ask thee please " + player_name + ", take it away.\"");
				}

				//Carrying real rune
				else if (UI_count_objects(PARTY, SHAPE_RUNE, QUALITY_ANY, FRAME_RUNE_HONOR))
				{
					say("\"Thou hast the Rune? Why then, let me see it!\"~He looks upon the Rune of Honor, and a distant smile touches his lips. \"'Tis good to see it again, after so long.~\"Please, place it upon the pedestal in the center of town, then come speak to me again.\"*");
					return;
				}

				//Carrying fake rune
				else if (UI_count_objects(PARTY, SHAPE_RUNE, QUALITY_ANY, FRAME_RUNE_REPLICA))
				{
					say("\"Thou hast the Rune? Why then, let me see it!\"~He looks upon the Rune of Honor, and frowns with puzzlement. \"Avatar, I believe someone has taken you for a fool!~This Rune is a fake -- though why anybody wouldst wish to falsify such a thing is beyond me.\" He sighs and shakes his head.");
				}
			
			case "But thou dost not believe so?" (remove):
				say("He sighs. \"Alas...I fear thou shalt find that the glory of thy virtuous path has faded somewhat, and many now look elsewhere for their spiritual compass.\" He glances across to the Fellowship Hall.~\"For some, the Rune might simply be an awkward reminder of a bygone era.");

				say("\"Fie, what am I saying? I do not wish to depress thee in return for thy noble gesture! I thank thee again most humbly Avatar, for thy faith and thine Honor.~Thou hast done this for us upon thine own initiative and with no offer of reward -- 'Tis mine hope that my people shall honor thy deed as it deserves.\"");

				//Finally! Closes conversation threads to do with Rune
				gflags[RUNE_QUEST_COMPLETE] = true;
		}
	}

	else if (event == PROXIMITY)
	{
		//Note: this behaviour only applies for when the player first meets Finnigan
		if (UI_get_schedule_type(item) == LOITER)
		{
			//reorganised to make it easier to add barks
			barks = [
				"@What a day...@",
				"@Another day, another gold coin...@",
				"@I shall search the area here...@",
				"@I am too old for this...@"
			];
			UI_item_say(item, randomIndex(barks));
		}
		//Otherwise, say generic NPC barks
		else scheduleBarks(item);
	}
}