//Gladstone the glassblower - reimplemented to add Rune of Honor quest.

const int GLADSTONE_RUNE_CHARGE = 50;	//how much Gladstone charges for making the replica
Gladstone 0x455 ()
{
	var polite_title;
	var wearing_fellowship;

	//flagged true when player has asked Gladstone to make the rune (means they don't have to do it another time)
	static var asked_to_make_replica;

	if (event == DOUBLECLICK)
	{
		polite_title = getPoliteTitle();
		wearing_fellowship = UI_wearing_fellowship();

		add(["name", "job", "bye"]);

		//Added for Rune of Honor quest
		if (gflags[MET_GLADSTONE] && gflags[KNOWS_ARTISAN_FOR_RUNE] && !gflags[GOT_REPLICA_RUNE])
		{
			if (asked_to_make_replica && UI_count_objects(PARTY, SHAPE_STONE_CHIPS, QUALITY_ANY, FRAME_SLATE)) add("brought slate");
			else add("Rune of Honor");
		}

		if (!gflags[MET_GLADSTONE])
		{
			item.say("You see a handsome craftsman with an intense, piercing gaze.");
			gflags[MET_GLADSTONE] = true;
		}
		else item.say("Gladstone shakes your hand and you can feel just a trace of sculptor's clay clinging to his palm. Although he hardly knows you, he treats you like an old friend.");

		converse([])
		{
			case "name" (remove):
				say("\"My name is Gladstone, " + polite_title + ". At thy service.\"");
				if (gflags[KNOWS_ARTISAN_FOR_RUNE] && !gflags[GOT_REPLICA_RUNE]) add("Rune of Honor");

			case "job":
				if (gflags[LEARNED_ABOUT_MINOC_MURDER])
				{
					say("\"I am a glassblower and a sculptor. I make mostly bottles and bowls. But in my time I have constructed all manners of statuary out of glass as well.\"");
					add(["glass", "Artist's Guild", "Minoc"]);
				}
				else
				{
					say("The man's eyes study you for a moment. \"Thou dost not know what has happened? William, our local Sawyer found two gypsies murdered in his sawmill.\"");
					gflags[LEARNED_ABOUT_MINOC_MURDER] = true;

					add("murders");
				}

			case "Minoc" (remove):
				say("\"There is active commerce here in Minoc sufficient to keep the Artist's Guild financially solvent. But in recent weeks I have come to fear we may not keep it going for very much longer. Unlike The Fellowship or Owen's monument, we do not have much political power. Now other events make our troubles seem less important.\"");
				add(["Fellowship", "monument", "power", "events"]);

			case "power" (remove):
				say("\"The Artist's Guild is taxed mercilessly by the Britannian Tax Council. Even in our best year it is a struggle to make ends meet. It seems that we are not considered important enough to be given an even chance.\"");
			
			case "events" (remove):
				say("\"Surely thou hast heard about the murders of Frederico and Tania?!\"");
				add("murders");

			case "Artist's Guild" (remove):
				say("\"The Artist's Guild is a group of local craftsmen. We sell our wares here in Minoc. While we are organized as a guild of equal members, I am tentatively the Guild head.\"");

			
			case "murders" (remove):
				say("\"I shudder to think such foul deeds are so freely committed in our fair town. Art thou investigating it? I wish thee all success in tracking the culprit. I barely knew Frederico or Tania, but I did meet their son Sasha once.\"");
				add("Sasha");

			case "Sasha" (remove):
				say("\"He befriended Seara and stayed the night with us once. He seemed like a nice young man, but misguided.\"");

			case "Fellowship" (remove):
				say("\"We do not get along very well with those people. I believe we have been unofficially marked as enemies of The Fellowship ever since all of the members of the Artist's Guild refused Elynor's invitation to join. They dislike us because they consider us to be indisposed toward Unity.\"");
				if (wearing_fellowship)
				{
					say("\"Dost thou think of us as thine enemy?\"");
					if (askYesNo())
					{
						say("\"Then get out of my sight! I do not wish to speak with thee!\"");
						return;
					}
					else say("\"Then I shall give thee the benefit of the doubt for now. But know that I do what I must to protect our Guild.\"");
				}
	
			case "monument" (remove):
				if (!gflags[COMPLETED_OWENS_QUEST])
				{
					say("\"Owen the shipwright is commissioning a statue of himself to be built in the center of town. The Artist's Guild decided to have nothing to do with this foolishness, of course. But just the word of this statue has spread and now orders are coming in from all over Britannia. Merchants want to have a ship built by the 'famous' Owen, master shipwright of Minoc.\"");
					add("statue");
				}
				else
				{
					say("\"Oh, yes, that reminds me! I cannot speak for long, I'm afraid. There is, after all, that barren slab in the center of town with nothing for it now. The Mayor has commissioned us to create something to fill the empty space. I don't want to say anything about it other than it's going to be wonderful. It will not be ready for quite a while but once it is, I hope thou wilt be able to return to Minoc then and see it. In better times perhaps. Farewell, then.\"*");
					return;
				}

			case "statue" (remove):
				say("\"I fear we have grievously miscalculated by thinking that if we boycotted the statue, it would not be built. It seems all the talk of it has made Owen into some sort of bizarre legend around this area, and the bloody statue hasn't even gone up yet! But that, I fear, is not the worst of the situation.\"");
				add("worst");

			case "worst" (remove):
				say("\"Once the statue is built, orders for ship-building are bound to increase even more! It won't take long before all local commerce will become affected by it. Owen will be purchasing more of the local resources, which will cause prices to rise, especially at the sawmill, and that will surely force the Artist's Guild into bankruptcy.\"");

			case "glass" (remove):
				say("\"I regret that I do not have any of my work for sale at present. Like our other artists I have a backlog of orders that will keep me busy for the foreseeable future. But there are several examples of my work, of which I am most proud, in the Guild Hall on display. If thou art interested, please have a look at them.\"");

			case "bye":
				say("\"Good journey, my friend.\"*");
				return;


			//The following has been added for the Rune of Honor quest
			case "Rune of Honor" (remove):
				say("Gladstone listens patiently as you tell him about your plans for a replica Rune, and that Julia recommended him as a sculptor.");

				say("\"'Tis been a long while since I have worked in stone -- nowadays my chosen forms are glass and clay. But aye, I could do such work for thee.~I do have a large backlog at present...but this sounds like a small enough job, I suppose I could slip it in.");
	
				say("\"However, I have never seen the Runes -- thou wouldst have to guide me with the design. Also, I do not have the necessary stone to work with. Bring some slate to me at my workshop, and I shall see what I can do.\"");

				asked_to_make_replica = true;

				//player has the slate already, go right ahead
				if (UI_count_objects(PARTY, SHAPE_STONE_CHIPS, QUALITY_ANY, FRAME_SLATE)) add("brought slate");

			case "brought slate" (remove):
				if (UI_get_schedule_type(item) == TEND_SHOP)	//is at workshop
				{
					say("He looks over the slab of slate. \"Ahh, good! This stone looks to be workable and free of blemish. Quite suitable.\"");

					if (gflags[COMPLETED_OWENS_QUEST]) say("\"Now, since you were instrumental in ridding us of that fool Owen, the least I could offer is to create thy replica for free. Wouldst thou like me to get started?\"");

					else say("\"However, the work shall not be trivial and I must charge for my craftsmanship. Wouldst thou pay " + GLADSTONE_RUNE_CHARGE + " gold for thy replica?\"");

					if (askYesNo())
					{
						//sting the player for the cash
						if (gflags[COMPLETED_OWENS_QUEST] || chargeGold(GLADSTONE_RUNE_CHARGE))
						{
							UI_remove_party_items(1, SHAPE_STONE_CHIPS, QUALITY_ANY, FRAME_SLATE, true);
							item.say("\"Very well then, let us begin!\" He fetches his chisels and takes the slate from you.");

							//player brought the real Rune to work from
							if (UI_count_objects(PARTY, SHAPE_RUNE, QUALITY_ANY, FRAME_RUNE_HONOR))
							{
								say("He works quickly and precisely, copying the design from the real Rune with a careful eye.");
							}
							else say("You aid him with a sketch of the Rune of Honor from memory. Gladstone laboriously copies from it, checking with you when your drawing is vague.");

							//Time passes...(two hours)
							UI_advance_time(2 * HOUR);

							say("In a couple of hours, the replica is ready. It looks surprisingly authentic, and Gladstone is obviously pleased with his handiwork.~\"Et voila! I hope it meets with thy satisfaction.\" He hands it to you.");

							//give them their shiny new fake Rune
							UI_add_party_items(1, SHAPE_RUNE, QUALITY_ANY, FRAME_RUNE_REPLICA, true);
							gflags[GOT_REPLICA_RUNE] = true;
						}
						else say("\"But thou dost not have enough, " + polite_title + "! Return when thy purse is feeling heavier.\"");
					}
					else say("\"Very well then. Ask again if thou changest thy mind.\"");
				}
				else say("\"Please, this is not the time. Ask me about this matter when I am at my workshop.\"");
		}
	}
	else if (event == PROXIMITY) scheduleBarks(item);
}