//Julia the Tinker, reimplemented to add Rune of Honor quest

const int OWENS_PLANS = 11;	//The quality of the scroll that contains Owen's shipbuilding plans
Julia 0x408()
{
	var polite_title;
	var party;
	var player_name;
	var options;

	if (event == DOUBLECLICK)
	{
		//commonly-used for conversations
		polite_title	= getPoliteTitle();
		party			= UI_get_party_list();
		player_name		= getAvatarName();

		//add standard conversation options
		add(["name", "job", "bye"]);

		if (gflags[LEARNED_ABOUT_PLANS])	add("plans");
		if (item in party)					add("leave");
		if (gflags[ASKED_JULIA_TO_LEAVE])	add("join");
		if (isNearby(SPARK) && !gflags[ASKED_JULIA_ABOUT_SPARK]) add("Spark");

		//added for Rune of Honor quest
		if (gflags[NEED_REPLICA_RUNE] && !gflags[GOT_REPLICA_RUNE])	add("Rune of Honor");

		if(!gflags[MET_JULIA])
		{
			item.say("You see Julia, a member of your party of adventurers from one of your previous visits to Britannia.");
			gflags[MET_JULIA] = true;
		}
		else item.say("\"It is good to speak with thee again, " + player_name + ",\" Julia greets you.");

		converse([])
		{
			case "name" (remove):
				say("\"Has it really been that long, " + player_name + "? 'Tis I, Julia!\"");

			case "job":
				if (gflags[LEARNED_ABOUT_MINOC_MURDER])
				{
					say("\"Since accompanying thee on thine adventures when thou wast last in Britannia, I have become the tinker of Minoc. I repair things for the people of the town. But my duties and obligations are not so pressing as to prevent me from joining thee again shouldst thou wish it. After all, when thou art in Britannia, thou hast usually come to repair very important things and help put the world to rights.\"");

					add(["tinker", "Minoc"]);
					if (!(item in party)) add("join");
				}
				else
				{
					say("\"Now is not the proper time for a joyous reunion, " + player_name + ". This town has been touched by a mysterious evil. There have been murders committed in Minoc.\"");
					gflags[LEARNED_ABOUT_MINOC_MURDER] = true;
					add(["murders", "Minoc"]);
				}
			
			case "tinker" (remove):
				say("\"It is not really what I wish to do with the rest of my life. I do not have the patience to be a proper tinkerer.~\"If thou didst ask me, I would say I have sacrificed enough!\"");
			
			case "join" (remove):
				if (UI_get_array_size(party) < 6)	//odd, Iolo joins if you have less than 8
				{
					if (gflags[ASKED_JULIA_TO_LEAVE]) say("\"Well... All right. But I did not like thee telling me to leave!\"");
					else say("\"Aye! It would be my pleasure!\"");

					gflags[JULIA_IN_PARTY] = true;
					UI_add_to_party(JULIA);
					add(["Iolo", "Shamino", "Dupre", "leave"]);
				}
				else say("\"I believe thou hast enough travellers for one group.\"");

			case "leave" (remove):
				say("\"Art thou sure thou dost want me to leave?\"");

				if (askYesNo())
				{
					say("\"Dost thou want me to wait here or should I go home?\"");
					converse(["wait here", "go home"])
					{
						case "wait here":
							say("\"Very well. I shall wait here until thou dost return.\"*");
							gflags[ASKED_JULIA_TO_LEAVE] = true;
							gflags[JULIA_IN_PARTY] = false;
							UI_remove_from_party(JULIA);
							UI_set_schedule_type(item, WAIT);
							return;
						
						case "go home":
							say("\"Well! Fine, if that is thy wish, I shall leave!\"*");
							gflags[ASKED_JULIA_TO_LEAVE] = true;
							gflags[JULIA_IN_PARTY] = false;
							UI_remove_from_party(JULIA);
							UI_set_schedule_type(item, LOITER);
							return;
					}
				}
				else say("\"Then I shall stay.\"");


			case "Minoc" (remove):
				say("\"'Tis a terrible thing to be happening in our town, these murders. Minoc was once a safe and quiet place.\"");
				add(["safe and quiet", "murders"]);

			case "safe and quiet" (remove):
				say("\"Well, at least safe, if not necessarily quiet. Especially with all the commotion caused by Owen and his monument.\"");
				add(["Owen", "monument"]);
			
			case "Owen" (remove):
				say("\"Owen is our local shipwright. Frankly, I think he is something of a fool.\"");

			case "monument" (remove):
				say("\"The Fellowship wanted to build a statue of Owen. That way they can use him as an example of the success of the Fellowship philosophy. It would also increase Owen's business to the point of upsetting the local economy and driving the Artist's Guild out of business!\"");
				if (gflags[COMPLETED_OWENS_QUEST]) say("\"And it would have worked if thou hadst not put a stop to their plans.\"");

			case "murders" (remove):
				say("\"Frederico and Tania were killed at the Minoc sawmill in a manner most gruesome.\"");
				add(["Frederico and Tania", "gruesome"]);

			case "Frederico and Tania" (remove):
				say("\"Frederico was the leader of the Gypsies, and Tania was his wife. They lived outside of town. I know nothing more about them.\"");

			case "gruesome" (remove):
				say("\"The manner in which Frederico and Tania were murdered suggests a ritual killing. From what I have been hearing it is similar to one that thou hast run across in Trinsic and one that occurred in Britain a while ago. 'Tis a most puzzling mystery.\"");

			
			case "plans" (remove):
				if (UI_count_objects(PARTY, SHAPE_SCROLL, OWENS_PLANS, FRAME_ANY) >= 1)
				{
					say("\"May I see them?\" She examines every line of the plans carefully. \"These designs are unsound. Ships built to these specifications will easily capsize and sink. Thou shouldst show these plans to the Mayor.\"");
					gflags[OWENS_PLANS_ARE_UNSAFE] = true;
				}
				else say("\"Karl has the plans to the ships Owen built that sank?! I would very much like see them. Perhaps I could help discover why those tragedies occurred.\"");
			
			case "Iolo" (remove):
				if (!isNearby(IOLO)) say("\"Perhaps we should go find Iolo and have him join us as well.\"");
				else
				{
					say("\"Hello, Iolo.\"*");
					IOLO.say("\"'Tis a pleasure to see thee again, Julia.\"*");
					IOLO.hide();
				}
			case "Shamino" (remove):
				if (!isNearby(SHAMINO)) say("\"Perhaps we should go find Shamino and have him join us as well.\"");
				else
				{
					say("\"Hello, Shamino!\"*");
					SHAMINO.say("\"Oh, Julia! Good of thee to be joining us again!\"*");
					SHAMINO.hide();
				}

			case "Dupre" (remove):
				if (!isNearby(DUPRE)) say("\"Perhaps we should go find Sir Dupre and have him join us as well.\"");
				else
				{
					say("\"Once again our paths cross, Sir Dupre!\"*");
					DUPRE.say("\"Julia! I was just wondering if we would ever see thee again!\"*");
					item.say("\"Well, thou canst wonder no more, Dupre.\"*");
					DUPRE.say("\"" + player_name + ", just between thou, myself and the lamppost, thou hadst better watch Julia. She hath a temper.\"*");
					DUPRE.hide();
				}
			
			case "Spark" (remove):
				say("\"And who is this fine young lad?\"");
				if (isNearby(SPARK))
				{
					SPARK.say("\"My name is Spark, milady.\"*");
					item.say("\"He is a cute one! And so well-mannered!\"");
					SPARK.say("Spark turns beet red.");
					SPARK.hide();
					gflags[ASKED_JULIA_ABOUT_SPARK] = true;	//what would this be?
				}

			case "bye":
				say("\"Goodbye, " + player_name + ".\"*");
				return;

			
			//Everything after this point has been added for the Rune of Honor quest
			case "Rune of Honor" (remove):
				say("You tell Julia that you are looking to make a replica of the Rune of Honor, and ask if she can help.");
				say("\"Why, art thou thinking to open a souvenir shop, " + player_name + "?\" She laughs, and then considers the matter.");

				say("\"I cannot say what stone the Runes were made of, for I have never seen its like. But, slate might make a good substitute.~\"I do know that the Mining Company had an old quarry to the east, at the top of the desert ranges. But 'twas abandoned long ago, and the machinery has probably rusted to pieces!");

				say("\"As for who could work slate...I am no good with stone, but I think Gladstone used to sculpt before he got into glassblowing. Thou shouldst ask him.\"");
				gflags[KNOWS_ARTISAN_FOR_RUNE] = true;
		}
	}
	else if (event == PROXIMITY) scheduleBarks(JULIA);
}