//Lord British - reimplemented to support Rune of Honor quest

//LB's healing conversation thread
extern performLBHealing 0x8B4(var var0000, var var0001, var var0002);

//Conversation thread for the crystal and ship deed for the Isle of Fire
extern giveFVDeedAndCrystal 0x8B5();

Lord_British 0x417 ()
{
	var player_name;

	var iolo_here;
	var dupre_here;
	var shamino_here;
	var done_healing;

	var asked_about_moongates;
	var asked_about_magic;

	var direction_from_avatar;
	var direction_inverted;
	var avatar_pos;
	var current_strength;
	var current_health;

	if (event == DOUBLECLICK)
	{
		player_name = getAvatarName();

		iolo_here		= isNearby(IOLO);
		dupre_here		= isNearby(DUPRE);
		shamino_here	= isNearby(SHAMINO);

		done_healing			= false;
		asked_about_moongates	= false;
		asked_about_magic		= false;

		//standard conversation options
		add(["name", "job", "bye", "Fellowship"]);

		//Oops...
		if (gflags[CAST_ARMAGEDDON])
		{
			item.say("\"Fool!! What possessed thee to cast that damned Armageddon Spell? I knew it was dangerous! Thou didst know it was dangerous!! Now look at us! We are all alone on the entire planet! Britannia is ruined! What kind of Avatar art thou!?! Now, with no Moongates working, we are both forced to spend eternity in this blasted wasteland!~~\"Of course, it could be viewed as a clever solution to all of our problems. After all, not even this so-called Guardian would want Britannia now!\"*");
			return;
		}

		//Completed the Forge of Virtue
		if (gflags[0x30C])
		{
			//hasn't been rewarded yet
			if (!gflags[LB_REWARDED_FOR_FV])
			{
				item.say("\"I felt the passing of the remains of Exodus from this realm. It has lifted a great weight from my shoulders. And so Avatar, I cannot let this accomplishment go unrewarded. Please kneel, my friend.\" Lord British holds out his hands as you obey his command.");
				item.hide();

				direction_from_avatar = directionFromAvatar(item);
				direction_inverted = (direction_from_avatar + 4) % 8;

				//LB runs his own function again, twice: once to grant the bonus (with sparkly effect) and again to congratulate afterwards. See the SCRIPTED event behaviour far below.
				//It appears he's meant to do some animation too, but doesn't in-game - look into this
				//(bug with original, schedule interfering?)
				UI_execute_usecode_array(item, [0x59, direction_inverted, 0x27, 0x0001, 0x27, 0x0002, 0x27, 0x0003, 0x55, 0x0417, 0x27, 0x0003, 0x27, 0x0002, 0x27, 0x000B, 0x55, 0x0417]);

				//Avatar kneels
				UI_execute_usecode_array(UI_get_avatar_ref(), [0x59, direction_from_avatar, 0x27, 0x0001, 0x6C, 0x27, 0x0001, 0x6D, 0x27, 0x0006, 0x6C, 0x27, 0x0001, 0x61]);
				return;
			}
		}
		//has not asked about earthquake yet
		else if (!gflags[0x2FE]) add("rumble");

		//Hasn't received orb of the moons yet
		if (!gflags[GOT_ORB])	add("Orb of the Moons");
		//Has met Weston but hasn't freed him yet
		if (gflags[0xCD] && !gflags[WESTON_FREED]) add("Weston");

		if (gflags[ASKED_LB_ABOUT_HEAL])	add("heal");
		//Has Alagner's notebook?
		if (gflags[0x127] && !gflags[ASKED_LB_ABOUT_GUARDIAN])	add("The Guardian");

		//Candice asked for LB's permission (added for Rune of Honor quest)
		if (gflags[NEED_PERMISSION_FOR_RUNE] && !gflags[GOT_PERMISSION_FOR_RUNE])	add("Rune of Honor");

		if (!gflags[MET_LORD_BRITISH])
		{
			item.say("You see your old friend Lord British, looking a bit older than when you last saw him. His eyes gleam at the sight of you.~~\"Welcome, my friend,\" he says, embracing you. \"Please. Tell me what brings thee to Britannia! Or, more importantly, what 'brought' thee here?\"");

			gflags[MET_LORD_BRITISH] = true;
			add("red Moongate");
			add("Orb of the Moons");
		}
		else item.say("\"Yes, " + player_name + "?\" Lord British asks.");
			
		converse([])
		{
			case "name" (remove):
				say("Lord British laughs. \"What, art thou joking, Avatar? Dost thou not recognize thine old friend?\"");

			case "job":
				say("Lord British rolls his eyes. \"Must we go through this formality?\" He laughs, shaking his head.");

				say("\"Very well. As thou well knowest, I am sovereign of Britannia and have been for some time now. Even though I come from thine homeland, I have chosen to live my life here.\"");

				add(["Britannia", "homeland"]);

			case "homeland" (remove):
				say("\"I know that it has been many a year since I visited our Earth, but surely thou dost remember that the two of us hail from the same time and place? And, as brothers in origin, thou shouldst also remember that thou canst ask me for aid at any time thou mightest require it.\"");
				add("aid");

			case "aid" (remove):
				say("\"Do not forget, Avatar, that I have the power to heal thee. That is one bit of magic that still seems to work for me. And I could probably provide thee with some equipment and a spellbook.\"");

				add(["equipment", "spellbook"]);

				if (!gflags[ASKED_LB_ABOUT_HEAL]) add("heal");
				gflags[ASKED_LB_ABOUT_HEAL] = true;
	
			case "Britannia" (remove):
				say("\"The state of the land could not be more prosperous. Dost thou realize that thou hast been away for 200 Britannian years?\" Lord British wags a finger at you.~~ \"I am certain that thy friends have rued thine absence. 'Tis a shame thou didst stay away so long! But... I am so very happy to see thee. Britannia is prosperous and abundant. Look around thee. Explore the newly refurbished castle. Travel the land. Peace is prominent in all quarters.~~\"Yes, Britannia has never been better. Well, almost never.\"");

				add(["friends", "castle", "almost never"]);
				if (!gflags[ASKED_LB_ABOUT_MAGIC] && !asked_about_magic) add("magic");

			case "almost never" (remove):
				say("\"Well, 'things' are indeed fine. It is the 'people' I am concerned about.~~\"There is something wrong in Britannia, but I do not know what it is. Something is hanging over the heads of the Britannian people. They are unhappy. One can see it in their eyes. There is nothing that is unifying the population, since there has been peace for so long.~~\"Perhaps thou couldst determine what is happening. I implore thee to go out amongst the people. Watch them in their daily tasks. Speak with them. Work with them. Break bread with them. Perhaps they need someone like the Avatar to take an interest in their lives.\"");
			
			case "red Moongate" (remove):
				say("You relate the story of how a red Moongate appeared behind your house and mysteriously took you to Trinsic.~~Lord British's brow creases as you speak. Finally he says, \"I did not send the red Moongate to fetch thee. Someone or something must have activated that Moongate. And that is strange indeed, because we have been having a bit of trouble with Moongates as of late. In fact, we have been having trouble with magic in general!\"");

				if (!asked_about_moongates) add("Moongates");
				if (!asked_about_magic) add("magic");

			case "Orb of the Moons" (remove):
				say("\"Mine has not worked since the troubles with magic began. In fact, none of the Moongates have been working reliably for quite a while!");
				say("\"Didst thou bring thine Orb of the Moons?\"");

				if(askYesNo()) say("\"Really? Where is it? Thou dost not have it on thee!");
				else say("\"I see.");

				say("\"Hmmm. Thou might be stranded in Britannia. Here. Why not try mine? I shall let thee borrow it. Perhaps it will work for thee. Be careful, though. The Moongates have become dangerous.\"");

				if (UI_add_party_items(1, SHAPE_ORB, QUALITY_ANY, FRAME_ANY, false))
				{
					say("Lord British hands you his Orb of the Moons.");
					gflags[GOT_ORB] = true;
				}
				else say("\"Thine hands are too full to take the Orb!\"");

				if (!asked_about_moongates) add("Moongates");
				if (!asked_about_magic) add("magic");

			case "castle" (remove):
				say("\"Yes, it has been redecorated since thy last visit. The architects and workers did a splendid job.\"~~The ruler leans toward you with a sour look on his face.~~ \"The only mar in the entire complex is that damn nursery!\"");
				add("nursery");

			case "nursery" (remove):
				say("\"I will not go near the place! Kings and dirty diapers do not mix. The Great Council talked me into implementing the nursery after several of my staff started having families. Although it was probably a necessity, I shall pretend it does not exist!\"");

			case "Trinsic" (remove):
				say("\"I have not been down there in many years. Has something happened there?\"");
				converse(["a murder", "nothing much"])
				{
					case "nothing much" (remove):
						say("\"Indeed. Then it seems that Trinsic has not changed much since I saw it last.\" His eyes twinkle.");
						break;

					case "a murder" (remove):
						say("\"Murder? In Trinsic?\" The ruler looks concerned.~~\"I have heard nothing about it. Art thou investigating it?\"");
						if (askYesNo()) say("\"Very good. It pleases me that thou art concerned about my people.\"");
						else say("\"Ah, but perhaps thou shouldst!\"");

						say("The king pauses a moment. \"Now that thou dost mention it, I have had reports of other similar murders in the past few months. In fact, there was one here in Britain three or four years ago. The body was mutilated in a ritualistic fashion. Apparently there is a maddened killer on the loose. But I have no doubt that someone such as thee, Avatar, can find him!\"");
						UI_pop_answers();				//restores the previous set of answers (this violates the converse() structure, but hey)
						add(["ritualistic", "killer"]);
						break;
				}
			case "ritualistic" (remove):
				say("\"I do not recall many details. Thou shouldst ask Patterson, the town mayor, about it. He may remember more.\"");
				gflags[LEARNED_ABOUT_BRITAIN_MURDER] = true;

			case "killer" (remove):
				say("\"That is, of course, only an assumption on my part. But that is all we have had to work with. Unless thou hast already uncovered some useful information?\"");
				if (gflags[LEARNED_ABOUT_HOOK]) add("Hook");
				if (gflags[LEARNED_ABOUT_CROWN_JEWEL]) add("Crown Jewel");

			case "Fellowship" (remove):
				say("\"They are an extremely useful and productive group of citizens. Thou shouldst most certainly visit the Fellowship Headquarters here in Britain and speak with Batlin. The Fellowship has done many good deeds throughout Britannia, including feeding the poor, educating and helping those in need, and promoting general good will and peace.\"");
				add(["Batlin", "Headquarters"]);
			
			case "Headquarters" (remove):
				say("\"Yes, it is not far from the castle, to the southwest. It is just south of the theatre.\"");

			case "Batlin" (remove):
				say("\"He is a druid who began The Fellowship about twenty years ago. He is highly intelligent, and is a warm and gentle human being.\"");

			case "Hook" (remove):
				say("\"A man with a hook?\" The king rubs his chin.~~\"No, I do not recall ever meeting a man with a hook.\"");

			case "Crown Jewel" (remove):
				say("\"I am afraid I cannot possibly know of every ship that comes through our ports. Thou shouldst check with Clint the Shipwright if thou hast not done so.\"");
			

			case "friends" (remove):
				say("\"Thou must mean Iolo, Shamino, and Dupre, of course.\"");
				add(["Iolo", "Shamino", "Dupre"]);
			
			case "Iolo" (remove):
				say("\"I have seen our friend rarely over the years. I understand he has been spending most of his time in Trinsic.\"");
				if (iolo_here)
				{
					say("\"Hello, Iolo! How art thou?\"*");
					IOLO.say("\"I am well, my liege! 'Tis good to see thee!\"*");
					IOLO.hide();
				}
				add("Trinsic");

			case "Shamino" (remove):
				say("\"That rascal does not come around very often, though I understand he spends most of his time in Britain these days!\"");

				if (shamino_here)
				{
					item.say("\"What dost thou have to say for thyself, Shamino?\"*");
					SHAMINO.say("\"Mine apologies, milord,\" Shamino says.*");
					item.say("\"What's this I hear of a woman? An actress? Hmmmm?\"*");
					SHAMINO.say("Shamino blushes and shuffles his feet.*");
					item.say("\"I suspected as much!\" the ruler says, laughing.");
					SHAMINO.hide();
				}
			
			case "Dupre" (remove):
				say("\"I have not seen that one since I knighted him. Typical -- I do the man a favor and he disappears! I heard he might be in Jhelom.\"");

				if (dupre_here)
				{
					say("\"Where hast thou been, Sir Dupre?\"*");
					DUPRE.say("\"Oh, here and there, milord,\" the fighter replies.*");
					item.say("\"I have very few friends from our homeland here in Britannia. Thou must make a point to visit more often! Especially since thou art a knight!\"*");
					DUPRE.say("\"If thou dost wish it, milord,\" Dupre says, bowing.*");
					DUPRE.hide();
				}
				add("Jhelom");

			case "Jhelom" (remove):
				say("\"A rather violent place, by all accounts. I have not had the pleasure of a visit in quite a while.\"");


			case "magic" (remove):
				say("\"Something is awry. Magic has not been working for the longest time. I even have trouble creating food with magic! It must be something to do with the magical ether.~~\"There are those who say that magic is dying, what with the trouble with the Moongates and the situation with Nystul. I am beginning to suspect that they might be right!\"");
				
				say("Lord British studies you a moment.");
				
				say("\"Perhaps magic will work much better for thee. Thou hast not been in Britannia long. It is possible that whatever has affected magic has not made its mark upon thee yet. Please try it. A spellbook is stored with the rest of thine equipment.\"");

				gflags[ASKED_LB_ABOUT_MAGIC] = true;
				add(["Nystul", "spellbook", "equipment"]);
				asked_about_magic = true;

				if (!asked_about_moongates) add("Moongates");

			case "Nystul" (remove):
				if (!gflags[BROKE_TETRAHEDRON])
				{
					if(!gflags[MET_NYSTUL]) say("\"Er... try talking to him.\"");
					else say("The king lowers his voice.~~\"He is acting oddly, isn't he? Something has happened to his mind. He doesn't seem to be able to concentrate on magic anymore.\"");
				}
				else say("\"He is beginning to act much more normally.\"");

			case "Moongates" (remove):
				say("\"The Moongates are not functioning! We cannot use them as we have in the past. Not only are they dysfunctional, they are, in fact, dangerous! One of my trusted sages used mine own Orb of the Moons to travel to the Shrine of Humility, and his body did shatter upon entering the gate! If only that mage in Cove hadn't gone mad!\"");

				add(["mad mage", "Cove"]);
				asked_about_moongates = true;

			case "mad mage" (remove):
				say("The ruler leans forward and speaks quietly.~~\"There is a mad mage in Cove by the name of Rudyom. Dost thou remember him? Rudyom was working with a magical substance called 'blackrock'. Before he went mad, he claimed that this mineral could solve the problems of the Moongates. I suggest that thou shouldst go to Cove and find him. Try to learn what it was he was doing with this blackrock material. It could be our only hope.\"");

				gflags[LEARNED_ABOUT_BLACKROCK] = true;
				giveExperience(20);
				add("Rudyom");

			case "Rudyom" (remove):
				say("\"He was a brilliant and respected mage. But something happened to him in recent years. He seemed to go completely senile.\"");

				if (gflags[MET_NYSTUL]) say("Suddenly, something jars Lord British's memory. \"I wonder if there is a connection with what happened to Rudyom and what has befallen Nystul!\"");
			
			case "Cove" (remove):
				say("\"Surely thou dost remember Cove. It is a very pleasant town to the east of Britain. Quite relaxing.\"");


			//what a bloody cop-out			
			case "The Guardian" (remove):
				say("\"I do not know of a 'Guardian'. Art thou sure he really exists? Thou shouldst investigate further.\"");
				gflags[ASKED_LB_ABOUT_GUARDIAN] = true;


			case "spellbook" (remove):
				say("\"Yes, I have a spellbook stored away with the rest of the equipment.\"");

			case "equipment" (remove):
				say("\"Thou art welcome to any of mine equipment. I keep it in a locked storeroom here in the castle. Thou wilt find the key in my study.\"");
				add(["storeroom", "study"]);

			case "storeroom" (remove):
				say("\"I am sure thou canst find it.\"~~The ruler smiles slyly. \"Consider it something of a game!\"");

			case "study" (remove):
				say("\"'Tis in the western end of the castle.\"");


			case "heal" (remove):
				performLBHealing(0, 0, 0);
				done_healing = true;

			case "Weston":			
				say("Lord British listens to your story about Weston. He looks concerned.~~\"I do not recall this case. Let me check... Hmmm...\" He quickly scans a large scroll.~~\"Imprisoned for the theft of one apple from the Royal Orchards... Ludicrous! Someone must have usurped mine authority. Thou mayest consider this man pardoned. An investigation will commence immediately into the circumstances surrounding his arrest, and into this fellow, Figg. My thanks to thee, Avatar.\"");

				gflags[WESTON_FREED] = true;
				giveExperience(20);
				UI_remove_npc(WESTON);	//deletes him from the universe (poor man)


			//FV stuff
			case "rumble" (remove):
				say("Lord British looks at you gravely, \"The foundation of Britannia was shaken with the rising of an island. This event was no random disaster, it was one of sorcerous intent.\"");
				add("island");
			
			case "island" (remove):
				say("\"Yes, " + player_name + ". I felt a great disturbance in the ether when this island arose from the sea. The island is none other than the Isle of Fire where thou defeated the Hellspawn Exodus.\"");
				add(["Isle of Fire", "Exodus"]);

			case "Isle of Fire" (remove):
				say("\"" + player_name + ", thou shouldst know that when I created the shrines of the Virtues, I also set upon this island three great shrines, dedicated to the Priciples of Truth, Love, and Courage.");

				say("They reside within the walls of the Castle of Fire. I never revealed this to thee before as I thought them forever lost when the Isle of Fire mysteriously sank beneath the waves.");

				say("The shrines are meant for the use of an Avatar only, and therefore a talisman will be necessary to use one.");

				say("The talismans are guarded by tests that thou shouldst have no problem passing if thou wishest to seek their counsel.\"");

				giveFVDeedAndCrystal();

			case "Exodus" (remove):
				say("\"Thy battle with that strange mixture of machine and spirit is now legendary. Do be careful if thou art going to the isle, for the remains of that being now reside in one of the chambers of the Castle of Fire.\"");

			
			case "bye":
				say("\"Goodbye, " + player_name + ". Do come back soon.\"*");
				return;


			//added for Rune of Honor quest
			case "Rune of Honor" (remove):
				say("You explain to the sovereign about your desire to return the Rune of Honor to Trinsic, and that the Museum needs his permission.");
				say("He nods. \"A noble goal indeed that thou hast set yourself, and I dare say the relics could do with some fresh air.~\"But tell me, how did the Rune come to be left here in the first place? Surely thou didst return it after thy quest to the place the Codex into the void?\"");

				converse(["'Twas an impostor who took it.", "Err...I sort of forgot."])
				{
					case "'Twas an impostor who took it.":
						say("\"Aye, lately I have been hearing the odd report of counterfeit Avatars defrauding the populace. 'Twould seem thine identity has great currency, my friend!");
						break;

					case "Err...I sort of forgot.":
						say("Lord British gets a gleam in his eye. \"Why, a hero cannot be expected to remember -everything-, now can they?~Ah well, 'tis better late than never as they say.\" He smiles knowingly.");
						break;
				}

				say("\"Very well, I agree to let thee bring the Rune back to Trinsic, and I shall let the Museum know in writing.~Thank thee for thine attention to this matter, 'tis good to have thee cultivating the Virtues once more!\"");
				gflags[GOT_PERMISSION_FOR_RUNE]	= true;		//Can now ask Candice about it again
				gflags[NEED_PERMISSION_FOR_RUNE]	= false;	//just to be tidy
		}
	}

	else if (event == PROXIMITY) scheduleBarks(LORD_BRITISH);

	else if (event == SCRIPTED)
	{
		//dunno why this would be getting called using SCRIPTED: if LB's schedule changes to TALK, that calls the NPC's function using DOUBLECLICK anyway
		if (gflags[CAST_ARMAGEDDON])
		{
			event = DOUBLECLICK;
			item.Lord_British();
			return;
		}

		else if (!gflags[LB_REWARDED_FOR_FV])
		{
			gflags[LB_REWARDED_FOR_FV] = true;
			avatar_pos = UI_get_object_position(UI_get_avatar_ref());
			
			UI_sprite_effect(7, avatar_pos[X] - 1, avatar_pos[Y] - 1, 0, 0, 0, -1);

			UI_play_sound_effect(67);

			current_strength	= UI_get_npc_prop(UI_get_avatar_ref(), STRENGTH);
			current_health		= UI_get_npc_prop(UI_get_avatar_ref(), HEALTH);

			if (current_strength < 60)	UI_set_npc_prop(UI_get_avatar_ref(), STRENGTH, 60 - current_strength);
			if (current_health < 60)	UI_set_npc_prop(UI_get_avatar_ref(), HEALTH, 60 - current_health);

			return;
		}

		player_name = getAvatarName();
		item.say("\"I congratulate and thank thee, " + player_name + ". Thy deeds continue to speak well of thee.\"");
		return;
	}
}